import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import javax.net.ssl.HttpsURLConnection;
import java.io.*;
import java.net.*;
import java.util.Scanner;

/**
 * Created by admin on 28.03.15.
 */

//main class
public class GoogleConsole {

    public GoogleConsole(){
        //set proxy settings
        System.setProperty("https.proxyHost", "proxy.ustu") ;
        System.setProperty("https.proxyPort", "3128") ;
        Authenticator.setDefault(new Authenticator() {
            protected PasswordAuthentication getPasswordAuthentication() {
            return new PasswordAuthentication("d.efremov", "H!c4db1lV".toCharArray());
            }
        });

        //read user's request from keyboard
        Scanner scanner = new Scanner(System.in);
        while(true){
            System.out.print("Google request: ");
            String request = scanner.nextLine();
            if("putinthebest".equals(request.trim())){
                System.out.println("Good Bye!");
                break;
            }
            if(request.isEmpty()){
                System.out.println("Error. Request is empty.");
            }else{
                System.out.println("Please, wait per seconds...");
                //safety string without places
                doRequest(request.replace(" ","+").trim());
            }
        }
    }

    public void doRequest(String request) {
        //make search request for mega-pro-google console
        URL url = null;
        InputStream inputStream = null;
        BufferedReader reader = null;
        try {
            url = new URL("https://www.google.ru/search?q="+request);
            HttpsURLConnection httpsURLConnection = (HttpsURLConnection) url.openConnection();
            httpsURLConnection.setRequestMethod("GET");
            httpsURLConnection.setRequestProperty("User-Agent", "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36");
            inputStream = httpsURLConnection.getInputStream();
            reader = new BufferedReader(new InputStreamReader(inputStream,"UTF-8"));

            StringBuffer sb = new StringBuffer();

            char[] buf = new char[1024];
            int x;
            while (true) {
                x = reader.read(buf);
                if (x==-1) {
                    reader.close();
                    break;
                }
                if (x==1024) sb.append(buf);
                if (x<1024) sb.append(buf, 0, x);
            }

            //jsoup library for parse html
            Document doc = Jsoup.parse(sb.toString());
            Elements elems = doc.getElementsByAttributeValue("target", "_blank");
            int number = 1;
            for (Element elem : elems) {
                if(!elem.hasAttr("class")) {
                    System.out.print(number +". "+ elem.text());
                    System.out.println(" [" + elem.attr("href") + "]");
                    number++;
                }
            }

            System.out.println();
            System.out.println("Status: "+ (number-1) + " results on "+ url.toString());
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (ProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            //safety exit
            if(reader != null){
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
